open String

let string_brange str s e =
       let n = length str
    in sub str s (n - s - e)

let string_of_htmltag tn attrs =
    (List.fold_left (fun out (t,v) -> out ^ " " ^ t ^ "=\"" ^ v ^ "\"") ("<" ^ tn) attrs)  ^ ">"

let print_htmltag tn attrs =
    print_string (string_of_htmltag tn attrs)

let html_escape s =
  let n = ref 0 in
    for i = 0 to length s - 1 do
      n := !n +
        (match unsafe_get s i with
    	    | '<' -> 4
	    | '&' -> 5
	    | _   -> 1)
    done;
    if !n = length s then s else begin
      let s' = create !n in
        n := 0;
        for i = 0 to length s - 1 do
          begin
            match unsafe_get s i with
            | '<' ->
                unsafe_set s' !n '&'; incr n;
		unsafe_set s' !n 'l'; incr n;
		unsafe_set s' !n 't'; incr n;
		unsafe_set s' !n ';'
            | '&' ->
                unsafe_set s' !n '&'; incr n;
		unsafe_set s' !n 'a'; incr n;
		unsafe_set s' !n 'm'; incr n;
		unsafe_set s' !n 'p'; incr n;
		unsafe_set s' !n ';'
            | c ->
                unsafe_set s' !n c
          end;
          incr n
        done;
        s'
      end
